'Program multipleksowego sterowania 4 wywietlaczy 7 segmentowych LED
'cyfra zaadowana do A bdzie wywietlana na wywietlaczu 1
'cyfra zaadowana do B bdzie wywietlana na wywietlaczu 2
'cyfra zaadowana do C bdzie wywietlana na wywietlaczu 3
'cyfra zaadowana do D bdzie wywietlana na wywietlaczu 4
'zmienna Kr1 steruje kropk wywietlacza 1
'zmienna Kr2 steruje kropka wywietlacza 2
'zmienna Kr3 steruje kropka wywietlacza 3
'zmienna Kr4 steruje kropka wywietlacza 4
'czstotliwo sterowania cyfr wynosi 250 Hz
'czyli czstotliwo odwieania 4 wywietlaczy
'wynosi ok. 250/4 = 62 Hz

$regfile = "m8def.dat"                                      'informuje kompilator o pliku
        'dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator o
        'czstotliwoci oscylatora
        'taktujcego mikrokontroler
Config Portd = Output                                       'port D jako wyjciowy
Config Pinb.0 = Output                                      'linia PB0 jako wyjciowa
Config Pinb.1 = Output                                      'linia PB1 jako wyjciowa
Config Pinb.2 = Output                                      'linia PB2 jako wyjciowa
Config Pinb.3 = Output                                      'linia PB3 jako wyjciowa
Config Timer0 = Timer , Prescale = 256                      'konfiguracja Timer0 jako
        'timer z podziaem
        'preskalera przez 256

Declare Sub Pobr_znaku(cyfra As Byte)                       'deklaracja procedury
        'pobierajcej kod cyfry do
        'wywietlenia z tablicy
On Timer0 Mult_wysw                                         'przerwanie od przepenienia
        'Timer0 skok nastpi do
        'podprogramu Mult_wysw
Dim A As Byte , B As Byte , C As Byte , D As Byte           'definicje zmiennych A, B, C,
        'D, w ktrych bdzie
        'przechowywana warto do
        'wywietlenia
Dim Nr_wysw As Byte                                         'zmienna okrelajca numer
        'zapalonego wywietlacza
Dim Kr1 As Bit , Kr2 As Bit , Kr3 As Bit , Kr4 As Bit       'zmienne bitowe sterujce
        'kropkami
Dim Wart As Byte                                            'zmienna Wart przechowujca
        'liczb do wywietlenia
W1 Alias Portb.0                                            'przypisanie linii PB0 nazwy W1
W2 Alias Portb.1                                            'przypisanie linii PB1 nazwy W2
W3 Alias Portb.2                                            'przypisanie linii PB2 nazwy W3
W4 Alias Portb.3                                            'przypisanie linii PB3 nazwy W4

Enable Interrupts                                           'odblokowanie globalnego
        'systemu przerwa
Enable Timer0                                               'odblokowanie przerwania od
        'przepenienia Timer0
Load Timer0 , 125                                           'zaadowanie do licznika
        'wartoci pocztkowej 131, bo
        '256 - 125 = 131
Do                                                          'pocztek nieskoczonej ptli
 A = 1                                                      'wywietlenie na pierwszym
        'wywietlaczu cyfry 1
 B = 2                                                      'wywietlenie na drugim
        'wywietlaczu cyfry 2
 C = 8                                                      'wywietlenie na trzecim
        'wywietlaczu cyfry 8
 D = 9                                                      'wywietlenie na czwartym
        'wywietlaczu cyfry 9
 Set Kr2                                                    'wczenie kropki
        'wywietlacza 2
 Set Kr4                                                    'wczenie kropki
        'wywietlacza 4
 Wait 5                                                     'opnienie 5 sekund
 D = 10                                                     'wywietlacz 4 zostanie
        'wyczony
 C = 10                                                     'wywietlacz 2 zostanie
        'wyczony
 Reset Kr4                                                  'wyczenie kropki
        'wywietlacza 4
 Reset Kr2                                                  'wyczenie kropki
        'wywietlacza 2
 Wait 5                                                     'opnienie 5 sekund
 Wart = 35                                                  'wpisanie do zmiennej Wart
        'wartoci 35, ktra zostanie
        'wywietlona na
        'wywietlaczach 1 i 2
 Wart = Makebcd(wart)                                       'zamiana wartoci zmiennej
        'Wart na warto zapisan
        'w kodzie BCD
 A = Wart And &B00001111                                    'wyodrbnienie (przez
        'maskowanie) i wywietlenie
        'pierwszej cyfry zapisanej
        'w zmiennej Wart (cyfra 5)
 Shift Wart , Right , 4                                     'przesunicie wartoci
        'drugiej cyfry w zmiennej
        'Wart na pozycje czterech
        'mniej znaczcych bitw
 B = Wart                                                   'wywietlenie na
        'wywietlaczu 2 cyfry 3
 Wait 5                                                     'opnienie 5 sekund
Loop                                                        'koniec ptli nieskoczonej
End                                                         'koniec programu

Sub Pobr_znaku(cyfra As Byte)                               'definicja procedury
        'Pobr_znaku
 If Cyfra < 10 Then                                         'jeeli warto otrzymanej do
        'wywietlenia cyfry < od 10,
  Portd = Lookup(cyfra , Kody7seg )                         'to wpisanie do portu D
        'warto kodu z tablicy
        'staych Kody7seg
 Else                                                       'w przeciwnym razie
  Portd = 0                                                 'wpisanie do portu D wartoci
        '0 ktra wygasza wywietlacz
 End If                                                     'koniec warunku If...Then
End Sub                                                     'koniec procedury

Mult_wysw:                                                  'podprogramu obsugi
        'przerwania od przepenienia
        'Timer0 w ktrym odbywa si
        'multipleksowanie
 Load Timer0 , 125                                          'zaadowanie do licznika
        'wartoci pocztkowej
 Set W1                                                     'wygaszenie wywietlacza 1
 Set W2                                                     'wygaszenie wywietlacza 2
 Set W3                                                     'wygaszenie wywietlacza 3
 Set W4                                                     'wygaszenie wywietlacza 4
 Select Case Nr_wysw                                        'w zalenoci od wartoci
        'Nr_wysw, wykonaj:
  Case 0:                                                   'gdy Nr_wysw = 0, to
   Call Pobr_znaku(a)                                       'wywoanie procedury
        'pobierajcej z tablicy kod
        'znaku dla wartoci A
   Portd.7 = Kr1                                            'wpisanie na linie PD7
        'sterujcej kropk wartoci
        'bitu Kr1 dla wywietlacza 1
   Reset W1                                                 'wczenie wywietlacza 1
  Case 1:                                                   'gdy Nr_wysw = 1, to
   Call Pobr_znaku(b)                                       'wywoanie procedury
        'pobierajcej z tablicy kod
        'znaku dla wartoci B
   Portd.7 = Kr2                                            'wpisanie na linie PD7
        'sterujcej kropk wartoci
        'bitu Kr2 dla wywietlacza 2
   Reset W2                                                 'wczenie wywietlacza 2
  Case 2:                                                   'gdy Nr_wysw = 2, to
   Call Pobr_znaku(c)                                       'wywoanie procedury
        'pobierajcej z tablicy kod
        'znaku dla wartoci C
   Portd.7 = Kr3                                            'wpisanie na linie PD7
        'sterujcej kropk wartoci
        'bitu Kr3 dla wywietlacza 3
   Reset W3                                                 'wczenie wywietlacza 3
  Case 3:                                                   'gdy Nr_wysw = 3, to
   Call Pobr_znaku(d)                                       'wywoanie procedury
        'pobierajcej z tablicy kod
        'znaku dla wartoci D
   Portd.7 = Kr4                                            'wpisanie na linie PD7
        'sterujcej kropk wartoci
        'bitu Kr4 dla wywietlacza 4
   Reset W4                                                'wczenie wywietlacza 4
 End Select                                                 'koniec instrukcji wyboru
 Incr Nr_wysw                                               'zwikszenie o jeden wartoci
        'Nr_wysw
 If Nr_wysw = 4 Then                                        'jeli warto Nr_wysw
        'osignie 4, to
  Nr_wysw = 0                                               'zeruj warto Nr_wysw
 End If
Return                                                      'powrt z podprogramu
        'przerwania

Kody7seg:                                                   'tablica staych Kody7seg
        'przechowujca kody
        'wywietlanych cyfr
'Kody cyfr
Data &B00111111 , &B00000110 , &B01011011 , &B01001111 , &B01100110,
Data &B01101101 , &B01111101 , &B00000111 , &B01111111 , &B01101111