'Program nadawania kodw w podczerwieni w standardach RC5, RC6 albo 
'SONY
'Przycisk S1 wysya kod w standardzie RC5
'Przycisk S2 wysya kod w standardzie RC6
'Przycisk S3 wysya kod w standardzie SONY

$REGFILE = "m8def.dat"					'informuje kompilator o pliku
							'dyrektyw mikrokontrolera
$CRYSTAL = 8000000					'informuje kompilator o
							'czstotliwoci oscylatora
							'taktujcego mikrokontroler
Config Pinc.0 = Input					'linia PC0 jako wejciowa
Config Pinc.1 = Input					'linia PC1 jako wejciowa
Config Pinc.2 = Input					'linia PC2 jako wejciowa
Config Pinb.1 = Output					'linia PB1 (OC1A) jako 
							'wyjciowa

Dim Togbit As Byte , Command As Byte , Address As Byte	'zmienne dla instrukcji 
							'wysyajcych kod w standardzie 
							'RC5 lub RC6

S1 Alias Pinc.2						'przypisanie nazwie Pinc.2 
							'nazwy S1
S2 Alias Pinc.1						'przypisanie nazwie Pinc.1 
							'nazwy S2
S3 Alias Pinc.0						'przypisanie nazwie Pinc.0 
							'nazwy S3

Set Portc.0						'doczenie do PC0 rezystora
							'podcigajcego
Set Portc.1						'doczenie do PC1 rezystora
							'podcigajcego
Set Portc.2						'doczenie do PC2 rezystora
							'podcigajcego

Do							'pocztek nieskoczonej ptli
	Debounce S1 , 0 , Rc5 , Sub			'jeli nacinity S1, to 
							'wykonanie podprogramu Rc5
	Debounce S2 , 0 , Rc6 , Sub			'jeli nacinity S2, to 
							'wykonanie podprogramu Rc6
	Debounce S3 , 0 , Sony , Sub			'jeli nacinity S3, to 
							'wykonanie podprogramu Sony
Loop							'koniec ptli nieskoczonej
End							'koniec programu

Rc5:							'podprogram Rc5
	Command = 12					'numer komendy do wysania 
							'- komenda wcz/wycz
	Togbit = 0					'wpisanie do Togbit wartoci 0
	Address = 0					'wpisanie do Address wartoci 0
	Do						'ptla wykonywana a do 
							'puszczenia przycisku S1
		Rc5send Togbit , Address , Command	'wysanie kodu RC5 zapisanego 
							'w zmiennych Address oraz 
							'Command
		Waitms 250				'opnienie 250 ms
	Loop Until S1 = 1				'jeli S1 = 1, to opuszczenie 
							'ptli
Return							'powrt z podprogramu

Rc6:							'podprogram Rc6
	Command = 13					'numer komendy do wysania 
							'- komenda wycisz
	Togbit = 0					'wpisanie do Togbit wartoci 0
	Address = 0					'wpisanie do Address wartoci 0
	Do						'ptla wykonywania a do 
							'puszczenia przycisku S2
		Rc6send Togbit , Address , Command	
							'wysanie kodu RC6 zapisanego 
							'w zmiennych Address oraz 
							'Command
		Waitms 250				'opnienie 250 ms
	Loop Until S2 = 1				'jeli S2 = 1, to opuszczenie 
							'ptli
Return							'powrt z podprogramu

Sony:							'podprogram Sony
	Do						'ptla wykonywania a do 
							'puszczenia przycisku S3
		Sonysend &HA90				'wysyany kod A90, czyli komenda
							'wcz
		Waitms 250				'opnienie 250 ms
	Loop Until S3 = 1				'jeli S3 = 1, to opuszczenie 
							'ptli
Return							'powrt z podprogramu

