'Program obsugujcy przez interfejs SPI 8-bitowy przetwornik A/C
'typu ADC0831

$regfile = "m8def.dat"                                      'informuje kompilator o pliku
       'dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator
       'o czstotliwoci oscylatora
       'taktujcego mikrokontroler
Config Pinb.5 = Output                                      'linia PB5 jako wyjciowa
Config Pinb.3 = Output                                      'linia PB3 jako wyjciowa
Config Pinb.2 = Output                                      'linia PB2 jako wyjciowa
Config Pinb.4 = Input                                       'linia PB4 jako wejciowa
Config Lcd = 16 * 2                                         'konfigurowanie typu
       'wywietlacza LCD
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 , Db7 = Portc.0 , E = Portc.4 , Rs = Portc.5       'konfigurowanie linii
       'mikrokontrolera, do ktrych
       'jest doczony wywietlacz LCD
Config Spi = Soft , Din = Pinb.4 , Dout = Portb.3 , Ss = None , Clock = Portb.5       'konfigurowanie interfejsu SPI

Dim Wart_ac As Byte                                         'zmienna dla wartoci odczytanej
       'z przetwornika A/C
Dim V As Single                                             'zmienna przechowujca obliczon
       'warto napicia
Dim Wart_nap As String * 3                                  'zmienna, do ktrej jest wpisana
       'przetworzona warto zmiennej V
       'na posta tekstow
Spiinit                                                     'inicjalizacja interfejsu SPI

Do                                                          'pocztek ptli programu
 Reset Portb.2                                              'odblokowanie przetwornika A/C
 Delay                                                      'opnienie
 Set Portb.5                                                'ustawienie linii zegarowej
'- poziom wysoki
 Delay                                                      'opnienie
 Reset Portb.5                                              'ustawienie linii zegarowej
' - poziom niski
 Delay                                                      'opnienie
 Spiin Wart_ac , 1                                          'odczytanie wartoci
       'z przetwornika przez SPI do
       'zmiennej Wart_ac
 Set Portb.2                                                'zablokowanie przetwornika A/C
 Cls                                                        'czyszczenie Lcd
 Lcd Wart_ac                                                'wywietlenie w pierwszej linii
       'LCD odczytanej wartoci
       'z przetwornika
 Lowerline                                                  'kursor do drugiej linii LCD
 V = Wart_ac * 0.020                                        'zamiana odczytanej wartoci
       'z przetwornika na napicie
       '- Wart_ac * ok. 20 mV
 Wart_nap = Fusing(v , "#.&&")                              'formatowanie zmiennej V do
       'formatu x.xx i zamiana tej
       'wartoci na tekst zapisywany do
       'Wart_nap
 Lcd Wart_nap                                               'wywietlenie przekonwertowanej
       'wartoci Wart_nap w drugiej
       'linii wywietlacza Lcd
 Waitms 100                                                 'opnienie 100 ms
Loop                                                        'koniec ptli Do...Loop
End                                                         'koniec programu
